import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;

public class Horchen extends Thread {
	Socket client = null;
	PrintWriter out;
    BufferedReader input;
	Server parent;
    String clientName;
    String peer;


        boolean active = true;
        boolean unangemeldet = true;

	public Horchen(Socket socket, Server argParent) {
		client = socket;
		parent = argParent;
	}

	public void run() {
		try {
			input = new BufferedReader(
					new InputStreamReader(
						client.getInputStream()
					));
			out = new PrintWriter(client.getOutputStream(), true);
			while (active) {
                                while(unangemeldet) {
                                        String a = input.readLine();
                                        if(a.startsWith("/I_AM")) {
                                                clientName = a.substring(5,a.length());
                                                boolean exists = parent.alreadyExists(clientName);
                                                exists = exists || clientName.equals("server");
                                                if(exists==false) {
                                                        parent.addLoggedClient(clientName, this);
                                                        unangemeldet = false;
                                                        parent.personalMessage(this,"server: OK");
                                                        parent.sendAll("server: HAS_JOINED " + clientName);
                                                }
                                                else {
                                                        parent.personalMessage(this,"server: ALREADY_TAKEN");
                                                }
                                        }
                                        else {}
                                }
                                String s = input.readLine();
                                read(s);
                        }
		}
                catch (Exception e)
                {
                 // e.printStackTrace

                  aufWiedersehen();
                }
	}


        public void read(String s) {
                if(s==null) aufWiedersehen();
                if(s.startsWith("/"))                   parseCmd(s);
                // wenn kein Kommando erkannt:
                else {
                  s = clientName + ": " +  s ;
                  if(peer == null) {
                  		parent.sendAll(s);
                  } else {
                  		parent.personalMessage(peer, s);
                  }
                }

        }

        public void aufWiedersehen() {
                active=false;

                parent.sendAll("server: QUIT " + clientName );
                parent.removeLoggedClient(clientName);
        }



        public void parseCmd(String s) {
          		if(s.startsWith("/P2P"))
          		{
          			String peerName = s.substring(4,s.length());
          			parent.startPeerToPeer(clientName, peerName);
          		}
          		if(s.startsWith("/STOP2P"))
          		{
          			if(peer != null) {
          			parent.stopPeerToPeer(clientName, peer);
                                }
          		}
                        if(s.startsWith("/BUDDYLIST"))
          		{
          			Collection keys = parent.alleClients.keySet();
                                String cmd = collectionToString(keys);
                                cmd = "server: BUDDYLIST" + cmd;
                                send(cmd);
          		}
              if(s.startsWith("/EXIT"))
              {
                aufWiedersehen();
                return;
              }




        }

	public void send(String s) {

		out.print(s + "\r\n" );
		out.flush();


	}
        public String collectionToString(Collection c) {
                String s = "";
		Iterator it = c.iterator();
                while(it.hasNext()) {
                    s = s + (String) it.next();
                }
                return s;

	}
}